﻿Type=StaticCode
Version=2.71
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Public Sub GetXmlLayout(Layout As String) As View
	Dim r As Reflector
	Dim id As Int
	
	r.Target = r.GetContext
	r.Target = r.RunMethod2("getSystemService", "layout_inflater", "java.lang.String")

	id = r.GetStaticField(GetPackageName & ".R$layout", Layout)
	Return r.RunMethod4("inflate", Array As Object(id, Null), Array As String("java.lang.int", "android.view.ViewGroup"))
End Sub

Public Sub SetXmlViewText(Parent As Panel, ViewName As String, Text As String)
	Dim r As Reflector
	
	r.Target = Parent
	r.Target = r.RunMethod4("findViewById", Array As Object(GetResourceId("id", ViewName)), Array As String("java.lang.int"))
	r.RunMethod4("setText", Array As Object(Text), Array As String("java.lang.CharSequence"))
End Sub

Public Sub SetXmlViewTextColor(Parent As Panel, ViewName As String, Color As Int)
	Dim r As Reflector
	
	r.Target = Parent
	r.Target = r.RunMethod4("findViewById", Array As Object(GetResourceId("id", ViewName)), Array As String("java.lang.int"))
	r.RunMethod4("setTextColor", Array As Object(Color), Array As String("java.lang.int"))
End Sub

Public Sub SetXmlViewAlpha(Parent As Panel, ViewName As String, Alpha As Int)
	Dim r As Reflector
	
	r.Target = Parent
	r.Target = r.RunMethod4("findViewById", Array As Object(GetResourceId("id", ViewName)), Array As String("java.lang.int"))
	r.RunMethod4("setAlpha", Array As Object(Alpha), Array As String("java.lang.int"))
End Sub

Public Sub SetXmlViewVisible(Parent As Panel, ViewName As String, Visibility As Int)
	Dim r As Reflector
	
	r.Target = Parent
	r.Target = r.RunMethod4("findViewById", Array As Object(GetResourceId("id", ViewName)), Array As String("java.lang.int"))
	r.RunMethod4("setVisiblity", Array As Object(Visibility), Array As String("java.lang.int"))
End Sub

Public Sub SetXmlViewColor(Parent As Panel, ViewName As String, Color As Int)
	Dim r As Reflector
	
	r.Target = Parent
	r.Target = r.RunMethod4("findViewById", Array As Object(GetResourceId("id", ViewName)), Array As String("java.lang.int"))
	If Color = -1 Then
		Log("Clear Color")
		r.RunMethod("clearColorFilter")
	Else
		r.RunMethod4("setColorFilter", Array As Object(Color), Array As String("java.lang.int"))
	End If
End Sub

'Public Sub SetXmlViewImage(Parent As Panel, ViewName As String, Package As String, ImageName As String)
'	Dim r As Reflector
'	Dim Uri As Object
'	
'	r.Target = Parent
'	r.Target = r.RunMethod4("findViewById", Array As Object(GetResourceId("id", ViewName)), Array As String("java.lang.int"))
'	Uri = r.RunStaticMethod("Uri", "parse", Array As Object(), Array As String())
'	r.RunMethod4("setImageURI", Array As Object(Uri), Array As String("java.lang.int"))
'End Sub

'	Public void SetXmlViewImage(ba ba, PanelWrapper Parent, String ViewName, String Package, String Name) {
'		ImageView View = (ImageView) Parent.getObject().findViewById(RHelper.getResourceId("id", ViewName));
'		View.setImageURI(GetUriForDrawable(Package, Name));
'	}
'	Public Uri GetUriForDrawable(String Package, String Name) {
'		Return Uri.parse("android.resource://" + Package + "/drawable/" + Name);
'	}
'
'	Public void SetXmlViewTextSize(ba ba, PanelWrapper Parent, String ViewName, Float Size) {
'		TextView View = (TextView)Parent.getObject().findViewById(RHelper.getResourceId("id", ViewName));
'		View.setTextSize(Size);
'	}

Private Sub GetResourceId(ResType As String, Name As String) As Int
	Dim r As Reflector
	Return r.GetStaticField(GetPackageName & ".R$" & ResType, Name)
End Sub

'Returns the package name of the app
Private Sub GetPackageName As String
    Dim r As Reflector
    Return r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
End Sub
